CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  Tv_Base     = 12

  _VCFG = ((%10111 | (Tv_base & 4 == 4) & %1000) << 26) | (Tv_base & %111000) << 6 | %111 << ((Tv_base & 4 == 4) & 4)
  _DIRA = %111 << ((Tv_base & 4 == 4) & 4) << ((Tv_base / 8) * 8)

  SCANLINE_BUFFER = $7F00
  scan_line=SCANLINE_BUFFER-4

VAR
  long  x_offset                ' X offset for smooth scroll
  long  y_offset                ' y offset for smooth scroll

  long  video_params[4]         'The parameters for the Video driver. 
        '[0] screen memory                            passed to the TV driver.
        '[1] scanline                                 passed to the TV driver.
        '[2] VCFG mode                                passed to the TV driver.
        '[3] VCFG DirA                                passed to the TV driver.

  long render_params[11]          ' Render parameters
        '[0] Cog number
        '[1] Cog total
        '[2] Scan line buffer
        '[3] Scan line
        '[4] Tile pointer
        '[5] Tile map
        '[6] X offset
        '[7] Y offset
        '[8] Sprite data

''used for rendering engine  
   long cog_number ''used for rendering engine
   long cog_total  ''used for rendering engine


   word tile_map[32*24]
   'byte PaletteIndexes[32*26]
   long Sprite_Data[1]
   byte io_data

OBJ
  VGA : "VGA8_256x192.spin"
  'graphic_driver : "Tile_Graphic_DRV_01_32x25b.spin"    ' The TV Driver.
  render_driver   : "Tile_Render_DRV_08_32_4bitNoSprites.spin" ' The rendering driver

PUB start | type, temp, random, timer, x1, y1

    cog_total := 3              ' Use 5 cogs...
    cog_number := 0

    'start the tv cog & pass it the parameter block
    video_params[0]  := SCANLINE_BUFFER
    video_params[1]  := SCANLINE_BUFFER-4 '@scan_line
    video_params[2]  := _VCFG
    video_params[3]  := _DIRA
    'video_params[6] := cog_total
    
    'graphic_driver.start(@video_params)
    'VGA.start(@video_params)
    
    x_offset := 0
    y_offset := 0

  
    render_params[0] :=  cog_number
    render_params[1] :=  cog_total
    render_params[2] :=  SCANLINE_BUFFER
    render_params[3] :=  SCANLINE_BUFFER-4 '@scan_line
    render_params[4] :=  @tile_image
    render_params[5] :=  @tile_map
    render_params[6] :=  @x_offset
    render_params[7] :=  @y_offset
    render_params[8] :=  @sprite_data
    render_params[9] :=  @Palettes
    'render_params[10] := @PaletteIndexes

        
    


    ' Start the rendering cogs.

    repeat
      render_params[0] := cog_number
      render_driver.start(@render_params)
      repeat 10000 ' Allow some time for previous cog to boot up before setting 'cog_number' again
      cog_number++
    until cog_number == cog_total

    VGA.start
    'graphic_driver.start(@video_params)

    temp := 0


    repeat y1 from 0 to (32*24)
      tile_map[y1] := 0

    repeat y1 from 0 to 5
      repeat x1 from 0 to 7
        PutTile_32(x1,y1,temp) ' <#23)
        Temp++

    ' Main loop

    repeat
      repeat while long[scan_line] <> 191 ' Wait for last line


Pub PutTile_32(x,y, Tile) | tl, pl
  tl := Tile * 16 + (Tile << 10)
  y:=y*4'+1
  tile_map[y*32 + (x*4)] := Tl
  tile_map[y*32 + (x*4)+1] := Tl + 1
  tile_map[y*32 + (x*4)+2] := Tl + 2
  tile_map[y*32 + (x*4)+3] := Tl + 3

  tile_map[(y+1)*32 + (x*4)] := Tl + 4
  tile_map[(y+1)*32 + (x*4)+1] := Tl + 5
  tile_map[(y+1)*32 + (x*4)+2] := Tl + 6
  tile_map[(y+1)*32 + (x*4)+3] := Tl + 7

  tile_map[(y+2)*32 + (x*4)] := Tl + 8
  tile_map[(y+2)*32 + (x*4)+1] := Tl + 9
  tile_map[(y+2)*32 + (x*4)+2] := Tl + 10
  tile_map[(y+2)*32 + (x*4)+3] := Tl + 11

  tile_map[(y+3)*32 + (x*4)] := Tl + 12
  tile_map[(y+3)*32 + (x*4)+1] := Tl + 13
  tile_map[(y+3)*32 + (x*4)+2] := Tl + 14
  tile_map[(y+3)*32 + (x*4)+3] := Tl + 15




  
DAT

tile_image
File "Turtle1.bin"

Palettes
File "Turtle1.pal.bin"




                        