OBJ
    'dbg    :       "PASDebug"                '<---- Add for Debugger

PUB start(params) 

  cognew(@entry,params)

  'dbg.start(31,30,@entry)                 '<---- Add for Debugger


DAT                             org     0
entry
  '--------- Debugger Kernel add this at Entry (Addr 0) ---------
    'long $34FC1202,$6CE81201,$83C120B,$8BC0E0A,$E87C0E03,$8BC0E0A
    'long $EC7C0E05,$A0BC1207,$5C7C0003,$5C7C0003,$7FFC,$7FF8
  '-------------------------------------------------------------- 

                                jmp     #initialization         'Start here...

par_pointer                     long  $0        ' Parameter pointer.

cog_number                      long  $0        ' The cog   
total_cogs                      long  $0        ' Total number of cogs  

temp                            long  $0

' Screen stuff
screen_buffer                   long  $0        ' Address used for screen buffer.
screen_buffer_ptr               long  $0        ' Pointer for screen buffer.
current_scan_line               long  $0        ' Current scan line.
screen_buffer_current           long  $0        ' Current Screen buffer address
scan_line_internal              long  $0        ' Internal counter 

tile_pointer                    long  $0        ' Pointer to tiles.
tile_map_ptr                    long  $0        ' Pointer to tile number.   

tile_address                    long  $0        ' The address read from the pointer.
tile_num                        long  $0        ' The tile to draw.
tile_row                        long  $0        ' The row in the tile to draw.
tile_row_calculated             long  $0        ' Calculated tile_row.

tiles_per_line                  long  32        ' This is 376/4 since each long is 4 pixels.
tiles_per_line1                 long  64        ' This is 376/4 since each long is 4 pixels.

tile_counter                    long  0         ' Counter for the tiles
pixel_counter                   long  0         ' Counter for pixels.

color                           long  0         ' The current pixel color
tile_buffer                     long  0         ' Buffer for a tile, four pixels

destination_increment           long  512       ' 9th bit, which is bit 0 for destination address

map_off                         long  0         ' Map offset.

x_offset                        long  0         ' X offset for smooth scroll
y_offset                        long  0         ' Y offset for smooth scroll   

Sprite_data_ptr                 long  0         ' Sprite pointer.


PalettePtr                      long  0
TempPalettPtr                   long  0
PaletteNbr                      long  0
TempPaletteNbr                  long  0

PalIndexPtr                     long  0
PalIndex                        long  0
ScanBufferPtr                   long  0
total_cogsminus1                long  $0        ' Total number of cogs Minus 1
Mask10bit                       long  %11_1111_1111

'***************************************************
'* The driver itself                               *
'***************************************************

initialization

                        ' Get parameters from parameter block, and pass them to COG code here
                        mov     par_pointer, PAR                                ' Get parameter block address
                        rdlong  cog_number, par_pointer                         ' Get Cog number
                        add     par_pointer, #4                                 ' Next parameter
                        rdlong  total_cogs, par_pointer                         ' Get total Cogs used
                        add     par_pointer, #4                                 ' Next parameter
                        rdlong  screen_buffer, par_pointer                      ' Get screen address
                        add     par_pointer, #4                                 ' Next parameter
                        rdlong  current_scan_line, par_pointer                  ' Get pointer to scan line request.
                        add     par_pointer, #4                                 ' Next parameter
                        rdlong  tile_pointer, par_pointer                       ' Get pointer to tiles.
                        add     par_pointer, #4                                 ' Next parameter
                        rdlong  tile_map_ptr, par_pointer                       ' Get pointer to tile map.
                        add     par_pointer, #4                                 ' Next parameter
                        rdlong  x_offset, par_pointer                           ' Get pointer to X offset.
                        add     par_pointer, #4                                 ' Next parameter
                        rdlong  y_offset, par_pointer                           ' Get pointer to Y offset.
                        add     par_pointer, #4                                 ' Next parameter
                        rdlong  Sprite_data_ptr, par_pointer                    ' Get pointer to sprite offset.
                        add     par_pointer, #4                                 ' Next parameter
                        rdlong  PalettePtr, par_pointer                    
                        add     par_pointer, #4                                 ' Next parameter
                        rdlong  PalIndexPtr, par_pointer

                        mov     total_cogsminus1, total_cogs
                        sub     total_cogsminus1, #1
                        
'-----------------------------------------------------------------------------

frame_loop
                        mov     scan_line_internal, cog_number                  ' First scan line to render
                        
:wait_for_sync          rdlong  temp, current_scan_line                         ' Get scanline
                        cmp     temp, #0 wz                                     ' Is it sync ?
                if_ne   jmp     #:wait_for_sync                                 ' If not, try again...

next_scan_line
                        mov     tile_counter, tiles_per_line                    ' Reset tiles
                        movd    write_scan_buffer, #scan_buffer                ' Set up pointer

                        mov     map_off, scan_line_internal                     ' Get Scan line
                        shr     map_off, #3                                     ' Divide by eight to get map row 0-24
                        shl     map_off, #6                                     ' Multiply with 32x2  for Map Width to get correct row address
                        add     map_off, tile_map_ptr                           ' Add address for tile map

                        mov     tile_row_calculated, scan_line_internal         ' Get scanline
                        and     tile_row_calculated, #7                         ' Mask off all but first 3 bits to get row number of tile
                        shl     tile_row_calculated, #2                         ' Multiply by 4 (bytes per row) to get correct row address
                        add     tile_row_calculated, tile_pointer               ' Add address of where tile graphics are


:tile_loop

                        rdword  temp, map_off                                   ' Get tile byte
                        mov     PalIndex, temp
                        and     temp, Mask10bit


                        shl     temp, #5                                        ' Multiply by 32 to get correct tile graphic (each tile is 32 bytes)
                        mov     tile_row, tile_row_calculated                   ' Get current tile row to work with 
                        add     tile_row, temp                                  ' The address for the current tile to draw
                        add     tile_row, pixel_counter                         ' Add pixel offset.


                        shr     PalIndex, #10
                        shl     PalIndex, #4

                        mov     TempPalettPtr, PalettePtr
                        add     TempPalettPtr, PalIndex

                        rdlong  PaletteNbr, tile_row

:tile_lop1
                        mov     TempPaletteNbr, PaletteNbr
                        and     TempPaletteNbr, #15
                        add     TempPaletteNbr, TempPalettPtr
                        rdbyte  color, TempPaletteNbr 
                        ror     PaletteNbr, #4
                        mov     tile_buffer, color
                        ror     tile_buffer, #8

                        mov     TempPaletteNbr, PaletteNbr
                        and     TempPaletteNbr, #15
                        add     TempPaletteNbr, TempPalettPtr
                        rdbyte  color, TempPaletteNbr
                        ror     PaletteNbr, #4
                        or      tile_buffer, color
                        ror     tile_buffer, #8

                        mov     TempPaletteNbr, PaletteNbr
                        and     TempPaletteNbr, #15
                        add     TempPaletteNbr, TempPalettPtr
                        rdbyte  color, TempPaletteNbr
                        ror     PaletteNbr, #4
                        or      tile_buffer, color
                        ror     tile_buffer, #8

                        mov     TempPaletteNbr, PaletteNbr
                        and     TempPaletteNbr, #15
                        add     TempPaletteNbr, TempPalettPtr
                        rdbyte  color, TempPaletteNbr
                        ror     PaletteNbr, #4
                        or      tile_buffer, color
                        ror     tile_buffer, #8

                        call    #write_scan_buffer


                        mov     TempPaletteNbr, PaletteNbr
                        and     TempPaletteNbr, #15
                        add     TempPaletteNbr, TempPalettPtr
                        rdbyte  color, TempPaletteNbr
                        ror     PaletteNbr, #4
                        mov     tile_buffer, color
                        ror     tile_buffer, #8

                        mov     TempPaletteNbr, PaletteNbr
                        and     TempPaletteNbr, #15
                        add     TempPaletteNbr, TempPalettPtr
                        rdbyte  color, TempPaletteNbr
                        ror     PaletteNbr, #4
                        or      tile_buffer, color
                        ror     tile_buffer, #8

                        mov     TempPaletteNbr, PaletteNbr
                        and     TempPaletteNbr, #15
                        add     TempPaletteNbr, TempPalettPtr
                        rdbyte  color, TempPaletteNbr
                        ror     PaletteNbr, #4
                        or      tile_buffer, color
                        ror     tile_buffer, #8

                        mov     TempPaletteNbr, PaletteNbr
                        and     TempPaletteNbr, #15
                        add     TempPaletteNbr, TempPalettPtr
                        rdbyte  color, TempPaletteNbr
                        ror     PaletteNbr, #4
                        or      tile_buffer, color
                        ror     tile_buffer, #8


                        call    #write_scan_buffer

                        add     map_off,#2

                        djnz    tile_counter, #:tile_loop                       ' Render all tiles
:wait
                        rdlong  temp, current_scan_line                         ' Get current scanline
                        cmps    temp, scan_line_internal wz, wc                 ' Is it the one the video driver wants ?
                if_b    jmp     #:wait                                          ' If not, wait for it.

start_tv_copy
                        mov     screen_buffer_ptr, screen_buffer                ' Reset buffer
                        movs    :nextcopy, #scan_buffer                         ' Set up scan buffer address
                        mov     tile_counter, tiles_per_line1                    ' Reset tile counter

                        ' Copy scanline from internal buffer to external buffer
:nextcopy
                        mov     temp,0-0                                        ' Get current long
                        add     :nextcopy, #1                                   ' Point to next long in the internal buffer
                        wrlong  temp, screen_buffer_ptr                         ' Write to external buffer
                        add     screen_buffer_ptr, #4                           ' Point to next long in external buffer
                        djnz    tile_counter, #:nextcopy                        ' Did we copy all tiles ?

scanlinedone
                        add     scan_line_internal, total_cogs                  ' Next scan line to render is current + total amount of render cogs
                        cmp     scan_line_internal, #191 wc, wz                 ' Check to see if we are done, if the next scanline > 239
                if_be   jmp     #next_scan_line                                 ' If not, prepare next line.
                        jmp     #frame_loop                                     ' And repeat for ever...

write_scan_buffer       mov     0-0, tile_buffer                                ' Add long to scan line buffer
                        add     write_scan_buffer, destination_increment       ' Move to next long in scanline buffer
write_scan_buffer_ret   ret

scan_buffer             long  0
                                                   